		>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
		>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
		>>    module's name: fnc	>>
		>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
		>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

>----------------------------------------------------------------------->

		>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
fnc:		> 	treatment function 	>
		>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

>----------------------->----------------------------------------->
>			>					  >
	1 		> f = g * pow(X1, p1) * pow(X2, p2) *  ...
>			>					  >
> ................................................................>
>	60	>g<	> scaling factor
>	30	>g<	> scaling factor
>	4	>g<	> scaling factor
	6	>g<	> scaling factor
	2	>N<	> number of pow(X, p) terms
>----------------------->----------------------------------------->

		>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
powxp:		> 	individual function 	>
		>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

>----------------------->----------------------------------------->
> Note: 
>	1. "t" is relative to injection starting time
>	2. this section may be repeated N times if N > 1 
>
>----------------------->----------------------------------------->
>			>					  >
>   	1		> type 1, sinewave 
>			>					  >
> ................................................................> 
>  X = k + sin(2 * PI *(t/T + alpha)) 
> ................................................................> 
>	1	>p<	> power factor for X
>	2	>T<	> period, in sec
>	0.	>alpha< > phase lead/delay, in fraction of period
>	0	>k<	> offset value for the waveform
> ................................................................> 
>----------------------->----------------------------------------->
>			>					  >
>	2		> type 2, triangular 
>			>					  >
> ................................................................> 
>	x = alpha + t/T
>	x = x - INT(x)		# INT(x) is the integer portion of X
> 	if (x >= 0 && x < 0.5) X = (k2 - k1) * x * 2 + k1;
> 	if (x >= 0.5 && x < 1.0) X = k2 - (k2 - k1) * (x-0.5) * 2;
> ................................................................> 
>	2	>p<	> power factor for X
>	4.0	>T<	> period, in sec
>	0.5	>alpha< > phase lead/delay, in fraction of period
>	-1	>k1<	> minimum value of X, -1, or 0
>	1	>k2<	> maximum value of X, 0 or 1
>----------------------->----------------------------------------->
>			>					  >
>	3		> type 3, linear ramp
>			>					  >
> ................................................................> 
>	if (t <= t1) X = k1;
> 	if (t > t1 && t < t2) X = (k2 - k1) * (t-t1)/(t2-t1) + k1;
> 	if (x >= t2) X = k2;
> ................................................................>
>	1	>p<	> power factor for X
>	0.5	>t1<	> time ramp starts, in sec
>	7.5	>t2<	> time ramp ends, in sec
>	-1	>k1<	> starting value of X, -1, 0 or 1
>	1	>k2<	> ending value of X, -1, 0 or 1
>----------------------->----------------------------------------->
>			>					  >
>	4		> type 4, square wave
>			>					  >
> ................................................................> 
>	x = alpha + t/T
>	x = x - INT(x)		# INT(x) is the integer portion of X
> 	if (x >= 0 && x < 0.5) X = k2;	# positive half comes first
> 	if (x >= 0.5 && x < 1.0) X = k1;
> ................................................................> 
>	1	>p<	> power factor for X
>	4	>T<	> period, in sec
>	0	>alpha< > phase lead/delay, in fraction of period
>	-1	>k1<	> minimum value of X, -1, or 0
>	1	>k2<	> maximum value of X, 0 or 1
>----------------------->----------------------------------------->
>			>					  >
	5		> type 5, exponential function
>			>					  >
> ................................................................> 
>	X = k1 + k2 * exp((t-t0)*u(t-t0)/tau)
>  i.e.
>	if (t < t0) X = k1 + k2;
>	else X = k1 + k2 * exp((t-t0)/tau)
> ................................................................> 
	1	>p<	> power factor for X
	0	>t0<	> delay time, in sec
	-0.5	>tau<   > time constant, in sec
	1	>k1<	> -1 to 1
	-1	>k2<	> -1 to 1
>----------------------->----------------------------------------->
	5		> type 5, exponential function
> ................................................................> 
	1	>p<	> power factor for X
	0	>t0<	> delay time, in sec
	-0.24	>tau<   > time constant, in sec
	0	>k1<	> -1 to 1
	1	>k2<	> -1 to 1
>----------------------->----------------------------------------->

